

		<?php
		
			/**
			*  	Name: 		ubb.class.php
			*	Developer: 	Stefan Visser
			*	Date:		9-3-2010
			**/
		
			class ubb {
			
				var $input;
				protected $return;

					public function MakeUbb ($input) {
						$this->return = $this->DoUbb($input);
						return $this->return;
					}
					
					public function DoUbb ($input) {
						$this->return = $input;
							
							# Make it unposible to use html chars.
							$this->return =  htmlspecialchars($this->return);
						
							# Convert UBB to HTML 
							$this->return = $this->Ubb2HTML($this->return);
							
							# Set Smiles
							$this->return = $this->MakeSmiles($this->return);
							
							# Remove javascript tags
							$this->return = $this->RemoveJS($this->return);
						
							# Make From 'NewLine' A br-tag
							$this->return = nl2br($this->return);
							
							return $this->return;
					}
					
					public function Ubb2HTML($input) {
						
						$input = preg_replace('/\[b\](.+?)\[\/b\]/is', '<b>\\1</b>', $input);	
						$input = preg_replace('/\[i\](.+?)\[\/i\]/is', '<i>\\1</i>', $input);
						$input = preg_replace('/\[u\](.+?)\[\/u\]/is', '<u>\\1</u>', $input); 
						$input = preg_replace( '/\[color=(.+?)\](.+?)\[\/color\]/is', '<span style="color: \\1;">\\2</span>', $input ); 
						$input = preg_replace( '/\[url=(.+?)\](.+?)\[\/url\]/is', '<a href="\\1">\\2</a>', $input ); 
						$input = preg_replace( '/\[url\](.+?)\[\/url\]/is', '<a href="\\1" />\1</a>', $input ); 
						$input = preg_replace( '/\[img\](.+?)\[\/img\]/is', '<img src="\\1" />', $input ); 	
						$input = preg_replace('_\[youtube\].*?(v=|v/)(.+?)(&.*?|/.*?)?\[/youtube\]_is', '[youtube]$2[/youtube]', $input);
						$input = preg_replace('_\[youtube\]([a-z0-9-]+?)\[/youtube\]_is', '<object width="320" height="265"><param name="movie" value="http://www.youtube.com/v/$1"></param><param name="wmode" value="transparent"></param><embed src="http://www.youtube.com/v/$1" type="application/x-shockwave-flash" wmode="transparent" width="320" height="265"></embed></object>', $input);
  						
						return $input;
						
					}
					
					public function MakeSmiles($input) {
						
						$input = str_replace(':)', '<img src="images/smiles/smile.gif"></img>', $input);
						$input = str_replace(':(', '<img src="images/smiles/cry.gif"></img>', $input);
						$input = str_replace(':s', '<img src="images/smiles/confused2.gif"></img>', $input);
						$input = str_replace(':S', '<img src="images/smiles/confused2.gif"></img>', $input);
						$input = str_replace(':D', '<img src="images/smiles/biggrin.gif"></img>', $input);
						$input = str_replace(':p', '<img src="images/smiles/tongue.gif"></img>', $input);
						$input = str_replace(':P', '<img src="images/smiles/tongue.gif"></img>', $input);
						$input = str_replace(':|', '<img src="images/smiles/neutral.gif"></img>', $input);
						$input = str_replace(';)', '<img src="images/smiles/wink.gif"></img>', $input);
						$input = str_replace(':o', '<img src="images/smiles/surprised.gif"></img>', $input);
						$input = str_replace(':O', '<img src="images/smiles/surprised.gif"></img>', $input);
						$input = str_replace('8|', '<img src="images/smiles/eek.gif"></img>', $input);
						$input = str_replace(':$', '<img src="images/smiles/ashamed.gif"></img>', $input);
						$input = str_replace('=DD', '<img src="images/smiles/biggrin.gif"></img>', $input);

						$input = str_replace(':ehh:', '<img src="images/smiles/ehh.gif"></img>', $input);
						$input = str_replace(':!:', '<img src="images/smiles/exclaim.gif"></img>', $input);
						$input = str_replace(':?:', '<img src="images/smiles/question.gif"></img>', $input);
						$input = str_replace(':wrong:', '<img src="images/smiles/naugthy.gif"></img>', $input);
						$input = str_replace(':arrow:', '<img src="images/smiles/arrow.gif"></img>', $input);
						$input = str_replace(':x:', '<img src="images/smiles/silenced.gif"></img>', $input);

						$input = str_replace('(A)', '<img src="images/smiles/angel.gif"></img>', $input);
						$input = str_replace('(a)', '<img src="images/smiles/angel.gif"></img>', $input);
						
						return $input;
					}
					
					public function RemoveJS($input) {
					
						$input = preg_replace( '/javascript:/i', '', $input ); 
						return $input;
						
					}
					
					
			
			}
			
		
		?>


